unit uMain;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, Dialogs, StdCtrls, ComCtrls, Buttons, XPMan, ExtCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    xpmnfst1: TXPManifest;
    lbl1: TLabel;
    dlgOpenPic1: TOpenPictureDialog;
    dlgOpen1: TOpenDialog;
    dlgSavePic1: TSavePictureDialog;
    dlgSave1: TSaveDialog;
    pnl1: TPanel;
    lbl2: TLabel;
    bbtnEncrypt: TBitBtn;
    bbtnDecrypt: TBitBtn;
    pb1: TProgressBar;
    bbtnInfo: TBitBtn;
    edtBPC: TEdit;
    udBitsPerChannel: TUpDown;
    lblBPC: TLabel;
    lblNote: TLabel;
    procedure bbtnEncryptClick(Sender: TObject);
    procedure bbtnDecryptClick(Sender: TObject);
    procedure bbtnInfoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses uProcess, ActiveX;

procedure TForm1.bbtnEncryptClick(Sender: TObject);
begin
  if dlgOpen1.Execute and dlgOpenPic1.Execute and dlgSavePic1.Execute then
    try
      try
        bbtnEncrypt.Enabled:= False;
        bbtnDecrypt.Enabled:= False;
        bbtnInfo.Enabled:= False;
        lblBPC.Enabled:= False;
        lblNote.Enabled:= False;
        edtBPC.Enabled:= False;
        udBitsPerChannel.Enabled:= False;
        pb1.Show;

        Encrypt(dlgOpen1.FileName, dlgOpenPic1.FileName, dlgSavePic1.FileName, udBitsPerChannel.Position, pb1);

        MessageBox( Application.Handle, PChar('Done!' + #13#10#13#10 + 'The file "' +
                    dlgSavePic1.FileName + '" was created.'),
                    'StegaImage', MB_OK + MB_ICONINFORMATION);
      finally
        pb1.Hide;
        bbtnEncrypt.Enabled:= True;
        bbtnDecrypt.Enabled:= True;
        bbtnInfo.Enabled:= True;
        lblBPC.Enabled:= True;
        lblNote.Enabled:= True;
        edtBPC.Enabled:= True;
        udBitsPerChannel.Enabled:= True;
      end;
    except
      on e: Exception do
        MessageBox(Handle, PChar('An error has occurred.' + #13#10#13#10 + e.Message), 'StegaImage', MB_OK + MB_ICONSTOP);
    end;
end;

procedure TForm1.bbtnDecryptClick(Sender: TObject);
begin
  if dlgOpenPic1.Execute and dlgSave1.Execute then
    try
      try
        bbtnEncrypt.Enabled:= False;
        bbtnDecrypt.Enabled:= False;
        bbtnInfo.Enabled:= False;
        lblBPC.Enabled:= False;
        lblNote.Enabled:= False;
        edtBPC.Enabled:= False;
        udBitsPerChannel.Enabled:= False;
        pb1.Show;

        Decrypt(dlgOpenPic1.FileName, dlgSave1.FileName, pb1);

        MessageBox( Application.Handle, PChar('Done!' + #13#10#13#10 + 'The file "' +
                    dlgSave1.FileName + '" was created.'),
                    'StegaImage', MB_OK + MB_ICONINFORMATION);

      finally
        pb1.Hide;
        bbtnEncrypt.Enabled:= True;
        bbtnDecrypt.Enabled:= True;
        bbtnInfo.Enabled:= True;
        lblBPC.Enabled:= True;
        lblNote.Enabled:= True;
        edtBPC.Enabled:= True;
        udBitsPerChannel.Enabled:= True;
      end;
    except
      on e: Exception do
        MessageBox(Handle, PChar('An error has occurred.' + #13#10#13#10 + e.Message), 'StegaImage',  MB_OK + MB_ICONSTOP);
    end;
end;

procedure TForm1.bbtnInfoClick(Sender: TObject);
begin
  ShowMessage(
  'In a 24-bit bitmap, each pixel is made up of (surprise, surprise) a 24-bit number. Each number is composed of three 8-bit '+
  'numbers (the R, G and B channels). These are the intensity of the Red, Green and Blue colors that create the final color of the pixel.'+ #13#10#13#10+
  'To hide something inside the image, we will replace the Least Significant Bit (this is, the "rightmost" bit) of each 8-bit channel '+
  'of every pixel, with the bits of the file we want to hide. ' + #13#10#13#10 +
  'The image will lose some quality because now the colors of the pixels are not the same, but it will go unnoticed to the human eye.' + #13#10#13#10 +
  'Obviously, since we are storing only 3 bits per pixel, the image must have a fenomenal size to accommodate just a tiny little file. '+
  'For example, if we want to hide 1 MB of data, we need an image with 2,796,203 pixels, which would have a size of something like 2,200 x 1,320 pixels. And that is a 8.3 MB file... :O' + #13#10#13#10 +
  'We could replace the 2, 3 or 4 rightmost bits of every channel in order to increase the amount of data we can hide, but the quality could decrease considerably.' + #13#10#13#10 +
  'Try 8 bits per channel and you''ll see what I''m talking about (amazingly, 7 normally produces intelligible -although very ugly- images).');
end;

// To prevent the nasty open dialog bug that occurs (at least in D7) bwhen the hint for a file is shown.

initialization
  OleInitialize(nil);

finalization
  OleUninitialize;

end.
